; requires concatenating the prelude

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Examples ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; print all primes below `256` in their decimal ASCII character form
(macro byte-primes () (
    (let:nve $a 1 (
        (while:re $a (
            (let:ne $flg (
                ;(printf%03d:r $a) (putc:v ':') (putc:v ' ')
                (let:nve $b 254 (
                    (tau:ra $a $b)
                    (ifnot:ze $b (
                        (printf%03d:r $a)
                        (newline)))))))
            (inc:a $a)))))))

; See the web page `https://blog.jfrech.com/223/`.
(macro Prouhet-Thue-Morse-sequence () (
    (putc:v '0')
    (pushA:v 0)
    (let:nve $inf 8 (
        (while:re $inf (
            (dec:a $inf)
            (let:nve $flg 1 (
                (while:re $flg (
                    (let:ne $x (
                        (popA:w $x)
                        (pushB:r $x)
                        (not:a $x)
                        (pushC:r $x)))
                    (nonempty?A:w $flg)))))
            (let:nve $flg 1 (
                (while:re $flg (
                    (let:ne $x (
                        (popB:w $x)
                        (pushA:r $x)
                        (nonempty?B:w $flg)))))))
            (let:nve $flg 1 (
                (while:re $flg (
                    (let:ne $x (
                        (popC:w $x)
                        (printDecimal:r $x)
                        (pushA:r $x)
                        (nonempty?C:w $flg)))))))))))))

; See the two web pages `https://codegolf.stackexchange.com/questions/233884
; /remove-oddly-nested-substrings` and `https://codegolf.stackexchange.com/a/234969`.
(macro ppcg233884 () (
    ; define parity cell
    (let:nve $parity 0 (
        ; read in character stream
        (let:nve $char 0 (
            (getc:w $char)
            (while:re $char (

                ; check if it is a bracket and update parity
                (let:nve $wasbracket 0 (
                    (let:nve $bracket 91 (
                        ; '['
                        (sub:ra $char $bracket)
                        (ifnot:re $bracket (
                            (not:a $parity)
                            (inc:a $wasbracket)))
                        ; ']'
                        (inc:a $bracket)
                        (inc:a $bracket)
                        (ifnot:ze $bracket (
                            (not:a $parity)
                            (inc:a $wasbracket)))))

                    ; only print on even parity when it was not a bracket
                    (ifnot:ze $wasbracket (
                        (ifnot:re $parity (
                            (putc:r $char)))))))

                (getc:w $char)))))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Main ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(macro main() (
    ;(stackInitialize) ; this is only needed when stack semantics are used
    (byte-primes)))

(main)
