(macro inc:a (x) (
    (pnt x)
    (bf +)))

(macro dec:a (x) (
    (pnt x)
    (bf -)))

(macro rd:w (x) (
    (pnt x)
    (bf ,)))

(macro wrt:r (x) (
    (pnt x)
    (bf .)))

;;;

(macro while:r& (flg bdy) (
    (pnt flg)
    (bf [)
    bdy
    (pnt flg)
    (bf ])))

(macro clr:z (x) (
    (while:r& x (
        (dec:a x)))))

(macro ld:w# (x v) (
    (clr:z x)
    (pnt x)
    (num v)))

(macro let:*& (x bdy) (
    (new x)
    bdy
    (fgt x)))

(macro let:*#& (x v bdy) (
    (let:*& x (
        (ld:w# x v)
        bdy))))

(macro add:za (x y) (
    (while:r& x (
        (dec:a x)
        (inc:a y)))))

(macro add:ra (x y) (
    (let:*#& z 0 (
        (while:r& x (
            (dec:a x)
            (inc:a y)
            (inc:a z)))
        (add:za z x)))))

(macro cpy:rw (x y) (
    (clr:z y)
    (add:ra x y)))

(macro let:*r& (x y bdy) (
    (let:*& x (
        (cpy:rw y x)
        bdy))))

;;;

(macro if:z& (flg bdy) (
    (while:r& flg (
        (clr:z flg)
        bdy))))

; `flg` has to be boolean (meaning of uppercase)
(macro if:Z& (flg bdy) (
    (while:r& flg (
        (dec:a flg)
        bdy))))

(macro if:z&& (flg true false) (
    (let:*#& $alt 1 (
        (if:z& flg (
            (dec:a $alt)
            true))
        (if:Z& $alt (
            false))))))

(macro if:r& (flg bdy) (
    (let:*r& $flg flg (
        (if:z& $flg bdy)))))

(macro if:r&& (flg true false) (
    (let:*r& $flg flg (
        (if:z&& $flg true false)))))

(macro ifnot:z& (flg bdy) (
    (let:*#& $flg 1 (
        (while:r& flg (
            (clr:z $flg)
            (dec:a flg)))
        (while:r& $flg (
            (dec:a $flg)
            bdy))))))

(macro ifnot:r& (flg bdy) (
    (let:*r& $flg flg (
        (ifnot:z& $flg bdy)))))

;;;

(macro not:a (flg) (
    (let:*# $flg 1 (
        (while:r& flg (
            (clr:z flg)
            (dec:a $flg)))
        (while:r& $flg (
            (inc:a flg)
            (dec:a $flg)))))))

(macro leq:??W (x y flg) (
    (ld:w# flg 1)
    (while:r& x (
        (ifnot:r& y (
            (clr:z flg)))
        (dec:a x)
        (dec:a y)))))

(macro grt:??W (x y flg) (
    (leq:??W (x y flg))
    (not:a flg)))

(macro geq:??W (x y flg) (
    (leq:??W y x flg)))

(macro lss:??W (x y flg) (
    (grt:?? y x flg)))

;;;

(macro putc:# (v) (
    (let:*#& $c v (
        (wrt:r $c)))))

(macro printBool:r (b) (
    (if:r&& b (
            (putc:# 't')
            (putc:# 'r')
            (putc:# 'u')
            (putc:# 'e'))
        (
            (putc:# 'f')
            (putc:# 'a')
            (putc:# 'l')
            (putc:# 's')
            (putc:# 'e')
        ))))

;;;

(macro main () (
    (let:*#& $a 7 (
        (let:*#& $b 7 (
            (let:*#& $flg 1 (
                (leq:??W $a $b $flg)
                (printBool:r $flg)))))))))

(macro main' () (
    (let:*#& $a 3 (
        (if:z& $a (
            (putc:# 'y')))))))

(main)
