; requires concatenating the prelude

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Testing ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(macro fundamentals-test () (
    (let:nve $a 38 (
        (let:nve $b 22 (
            (let:ne $c (
                (add:ra $a $b)
                (assert:rv $b 60)
                (dec:a $b)
                (assert:rv $b 59)
                (cpy:rw $b $c)
                (assert:rv $b 59)
                (assert:rv $c 59)
                (add:ra $c $a)
                (assert:rv $c 59)
                (assert:rv $a 97)))))))))

(macro alias-test () (
    (let:nve $c 'j' (
        (alias wakka $c (
        (putc:r $c)
        (let:nve $^ 224 (
            (add:ra $^ $c)
            (putc:r wakka)))))))))

(macro print-dots () (
    (let:nve $c 32 (
        (putc:r $c)
        (add:va 14 $c)
        (putc:r $c)
        (putc:r $c)
        (putc:r $c)))))

(macro divmod-test () (
    (let:nve $a 123 (
        ;(printf%03d:r $a) (newline)
        (let:nve $b 13 (
            (let:ne $c (
                (divmod:arw $a $b $c)
                (assert:rv $a 6)
                ;(printf%03d:r $c) (newline)
                (assert:rv $c 9)
                ;(printDecimal:r $c) (newline)
                (assert:rv $b 13)))))))))

(macro less-than-or-equal-to-test () (
    (let:nve $a 2 (
        (let:nve $b 3 (
            (let:ne $flg (
                (set:wv $flg 0)
                (<=:rrb $a $b $flg)
                (assert:rv $a 2)
                (assert:rv $b 3)
                (assert:rvs $flg 1 2islessthan3)
                ;(printBoolean:r $flg)
                ;(putc:v '\n')
                (set:wv $a 6)
                (set:wv $b 5)
                (<=:uub $a $b $flg)
                (assert:rvs $flg 0 6isnotlessthan5)
                ;(printBoolean:r $flg)
                ))))))))

(macro read-stack-a () (
    (putc:v '^')
    (putc:v 'A')
    (putc:v '\n')

    (let:ne $flg (
        (nonempty?A:w $flg)
        (while:re $flg (
            (let:ne $x (
                (popA:w $x)
                (printf%03d:u $x)
                (newline)))
            (nonempty?A:w $flg)))))

    (putc:v '\n')))

(macro characters-on-the-stack-test () (
    (comment
    (let:nve $a 'j' (
        (let:nve $b '~' (
            (pushA:r $b)
            (pushB:r $b)
            ;(pushA:r $b)
            ;(pushA:r $b)
            (pushA:r $a)))))
    )

    (comment
    (let:nve $A '@' (
        (popA:w $A) (putc:r $A)
        (popB:w $A) (putc:r $A)
        (popA:w $A) (putc:r $A)))
    )

    (pushA:v 'a')
    (pushA:v 'b')
    (pushA:v 'C')

    (comment
    (let:ne $c (
        (popA:w $c) (putc:r $c) (clr:z ORIGIN)
        (popA:w $c) (putc:r $c) (add:va 33 ORIGIN)
        (popA:w $c) (putc:r $c)))
    )


    (read-stack-a)

    (comment
    (let:nve $flg 1 (
        (pushA:v 0)
        (while:re $flg (
            (let:ne $X (
                (popA:w $X)
                (if:re $X (
                    (putc:r $X))
            )))
            (nonempty?A:w $flg)))))
    )
    ))
