" Jonathan Frech, 2019-08-02, 2019-08-03, 2019-08-04, 2019-08-07, 2019-08-09,
"                 2019-12-27, 2021-09-03
" a vim syntax highlighting definition for the brainfuck compiler projec t

" --- Shortcomings -------------------------------------------------------------
" Nested block comments are currently problematic.


syn keyword bcpMeta      macro include alias derive
syn keyword tapeAbstraction new pnt num fgt bf ass

syn keyword bcpWakka     WAKKA TODO FIXME

syn match bcpHint ':\([^ \t():]*:[^ \t()]*\)\@![a-z]*'

syn match bcpCharacter '\(^\|[ \t()]\)\@<=\'[^ \t();\\]\'\([ \t();]\|$\)\@='
syn match bcpCharacter '\(^\|[ \t()]\)\@<=\'\\[abfnrtv]\'\([ \t();]\|$\)\@='
syn match bcpSpecialChar '\(^\|[ \t()]\)\@<=\'\\\(space\|semicolon\)\'\([ \t();]\|$\)\@=' " todo
syn match bcpCharError '\(^\|[ \t()]\)\@<=\'[ \t();]\'\([ \t();]\|$\)\@='

syn match bcpNumber '\(^\|[ \t()]\)\@<=[^ \t();]*#[^ \t();]*'
syn match bcpNumber '\(^\|[ \t()]\)\@<=\([0-9]\+\|0[xX][0-9a-fA-F]\+\|0[oO][0-8]\+\)\($\|[ \t()]\)\@='
syn match bcpLocal '\(^\|[ \t()]\)\@<=[^ \t();]*\$[^ \t();]*'

syn match bcpComment ';[^\n]*' contains=bcpWakka
syn match bcpSingleBlockComment '([ \t]*comment)'
syn region bcpBlockComment start='([ \t]*comment\([ \t;(]\|$\)' end=')' contains=bcpBlockOnelineComment,matchingParentheses,bcpWakka containedIn=matchingParentheses

syn region matchingParentheses start='(' end=')' transparent


hi def link bcpComment            Comment
hi def link bcpSingleBlockComment Comment
hi def link bcpBlockComment       Comment

hi def link bcpMeta               Operator

hi def link bcpLocal              Identifier
hi def link bcpHint Type

hi def link bcpNumber             Number
hi def link tapeAbstraction       Function
hi def link bcpUndefined          Error

hi def link bcpCharacter Character
hi def link bcpSpecialChar SpecialChar
hi def link bcpCharError Error

hi def link bcpWakka Todo
